#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <sys/stat.h>
#include <pwd.h>
#include <grp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <errno.h>

#define BUF_MAX 255

int dir_is_proc(const char *dname)
{
	if (dname == NULL || *dname == 0)
		return 0;

	while (isdigit(*dname))
		++dname;

	return (*dname == 0);
}

int main(int argc, char *argv[])
{
	DIR *dirh;
	char dir[BUF_MAX+1];
	struct dirent  *dp;
	struct stat     st;
	struct passwd  *pw;

	dirh = opendir("/proc");

	if (dirh == NULL) {
		fprintf(stderr, "Can't get open directory '%s': %s\n", dir, strerror(errno));
		exit(1);
	}
	
	printf("%-8s%6s  %s\n",  "UID", "PID", "CMD");

	while ((dp = readdir(dirh)) != NULL) {

		char* pr = dp->d_name;
		char ss[PATH_MAX]; 
		char str[PATH_MAX];
		char *b;
		char buf[1024];
		char pname[NAME_MAX];
		
		if (dir_is_proc(pr)) {	
			
			int pid = atoi(pr);
			
			snprintf(str, sizeof(str), "/proc/%s/cmdline", pr);
			
			FILE *f;
			f = fopen(str, "r");
			
			*ss = 0;
			
			if (f == NULL) {
				fprintf(stderr, "Error opening file \n", str);
			} else {
				fread(ss, 1, PATH_MAX, f);
				ss[PATH_MAX] = '\0';
			}

			fclose(f);

			snprintf(str, sizeof(str), "/proc/%s/stat", pr);
			
			f = fopen(str, "r");
			
			if (f == NULL) {
				fprintf(stderr, "Error opening file \n", str);
			} else {
				char *ptr;
				fscanf(f, "%s %s", buf, buf);
				b = strchr(buf, '(');
				
				if (!b)
					continue;
				ptr = ++b;
				b = strchr(b, ')');
				
				if (!b)
					continue;
				
				*b++ = 0;
				strncpy(pname, ptr, sizeof(pname));
				pname[0] = '[';
				strcat(pname, "]");
			}
			
			fclose(f);
			
			if (*ss == 0) strcpy(ss, pname);
			
			int ERR = stat(str, &st);
			
			if (ERR) {
				fprintf(stderr, "Error stat \n", str);
			} else {
				int uid = st.st_uid;
				pw = getpwuid(uid);
			}

			if (pw != NULL) 
				printf("%-8s%6s  %s\n",  pw->pw_name, pr,  ss);
		}
	}
	

	closedir(dirh);
	return EXIT_SUCCESS;
}